; file.s

	GET	macros.s

	AREA	|____file_size|, CODE, READONLY
	EXPORT	file_size
file_size

	STMFD	r13!,{r4,r5,lr}
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
	TEQ	r0,#1
	MOVEQ	r0,r4
	MOVNE	r0,#-1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_direxists|, CODE, READONLY
	EXPORT	file_direxists
file_direxists

	STMFD	r13!,{r4,r5,lr}
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
	TEQ	r0,#2
	MOVEQ	r0,#1
	MOVNE	r0,#0
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_getloadaddr|, CODE, READONLY
	EXPORT	file_getloadaddr
file_getloadaddr

	STMFD	r13!,{r4,r5,lr}
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
	TEQ	r0,#1
	MOVEQ	r0,r2
	MOVNE	r0,#-1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_getexecaddr|, CODE, READONLY
	EXPORT	file_getexecaddr
file_getexecaddr

	STMFD	r13!,{r4,r5,lr}
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
	TEQ	r0,#1
	MOVEQ	r0,r3
	MOVNE	r0,#-1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_getattr|, CODE, READONLY
	EXPORT	file_getattr
file_getattr

	STMFD	r13!,{r4,r5,lr}
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
	TEQ	r0,#1
	MOVEQ	r0,r5
	MOVNE	r0,#-1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_load|, CODE, READONLY
	EXPORT	file_load
file_load

	STMFD	r13!,{r4,r5,lr}
	MOV	r2,r1
	MOV	r3,#0
	MOV	r1,r0
	MOV	r0,#255
	SWI	XOS_File
	TEQ	r0,#1
	MOVEQ	r0,r4
	MOVNE	r0,#-1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_savetype|, CODE, READONLY
	EXPORT	file_savetype
file_savetype

	STMFD	r13!,{r4,r5,lr}
	MOV	r4,r1
	ADD	r5,r2,r4
	MOV	r1,r0
	MOV	r0,#10
	MOV	r2,r3
	MOV	r3,#0
	SWI	XOS_File
	MOVVC	r0,#0
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_sizetostr|, CODE
	EXPORT	file_sizetostr
file_sizetostr

	ADR	r1,fsts_str
	MOV	r2,#16
	SWI	XOS_ConvertFileSize
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

fsts_str
	%	16

	AREA	|____file_typetostr|, CODE
	EXPORT	file_typetostr
file_typetostr

	MOV	r2,r0
	MOV	r0,#18
	SWI	XOS_FSControl
	STR	r2,ftts_str
	STR	r3,ftts_str+4
	ADR	r0,ftts_str
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

ftts_str
	%	12

	AREA	|____file_datetostr|, CODE
	EXPORT	file_datetostr
file_datetostr

	ADR	r1,fdts_str
	MOV	r2,#64
	SWI	XOS_ConvertStandardDateAndTime
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

fdts_str
	%	64

	AREA	|____file_gettype|, CODE, READONLY
	EXPORT	file_gettype
file_gettype

	STMFD	r13!,{r4-r6,lr}
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
	MOVVS	r0,#-3
 [ arm32
	LDMVSFD	r13!,{r4-r6,pc}
 |
	LDMVSFD	r13!,{r4-r6,pc}^
 ]
	TEQ	r0,#0
	MOVEQ	r0,#-2
 [ arm32
	LDMEQFD	r13!,{r4-r6,pc}
 |
	LDMEQFD	r13!,{r4-r6,pc}^
 ]
	TEQ	r0,#2
	BEQ	fgt_dir
	MOV	r4,#&ff<<24
	ORR	r4,r4,#&f0<<16
	AND	r5,r4,r2
	TEQ	r5,r4
	MOVNE	r0,#-1
 [ arm32
	LDMNEFD	r13!,{r4-r6,pc}
 |
	LDMNEFD	r13!,{r4-r6,pc}^
 ]
	MOV	r0,r2,LSL#12
	MOV	r0,r0,LSR#8+12
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]
fgt_dir	LDRB	r4,[r1]
fgt_dr1	LDRB	r0,[r1],#1
	TEQ	r0,#'.'
	LDREQB	r4,[r1]
	CMP	r0,#32
	BCS	fgt_dr1
	TEQ	r4,#'!'
	MOVEQ	r0,#&2000
	MOVNE	r0,#&1000
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____file_getdate|, CODE, READONLY
	EXPORT	file_getdate
file_getdate

	STMFD	r13!,{r4-r6,lr}
	MOV	r2,#0
	STR	r2,[r1]
	STRB	r2,[r1,#4]
	MOV	r6,r1
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
 [ arm32
	LDMVSFD	r13!,{r4-r6,pc}
 |
	LDMVSFD	r13!,{r4-r6,pc}^
 ]
	MOV	r4,#&ff<<24
	ORR	r4,r4,#&f0<<16
	AND	r5,r4,r2
	TEQ	r5,r4
	STREQB	r2,[r6,#4]
	STREQ	r3,[r6,#0]
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____file_getdatefromloadexec|, CODE, READONLY
	EXPORT	file_getdatefromloadexec
file_getdatefromloadexec

; r0 is load
; r1 is exec
; r2 ^ date
	MOV	r3,#0
	STR	r3,[r2]
	STRB	r3,[r2,#4]
	MOV	r3,#&ff<<24
	ORR	r3,r3,#&f0<<16
	AND	r12,r3,r0
	TEQ	r12,r3
	STREQB	r0,[r2,#4]
	STREQ	r1,[r2,#0]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____file_savewithdate|, CODE, READONLY
	EXPORT	file_savewithdate
file_savewithdate

	LDR	r12,[r13]
	STMFD	r13!,{r4-r6,lr}
	LDR	r5,[r12,#0]
	LDRB	r6,[r12,#4]

	MOV	r4,r1
	ADD	r12,r2,r4
	MOV	r1,r0
	MOV	r0,#0
	MOV	r2,r3,LSL#8
	ORR	r2,r2,r6
	ORR	r2,r2,#&ff<<24
	ORR	r2,r2,#&f0<<16
	MOV	r3,r5
	MOV	r5,r12
	SWI	XOS_File
	MOVVC	r0,#0
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____file_getcurrentdate|, CODE, READONLY
	EXPORT	file_getcurrentdate
file_getcurrentdate

	MOV	r1,#3
	STRB	r1,[r0]
	MOV	r1,r0
	MOV	r0,#14
	SWI	XOS_Word
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____file_settype|, CODE, READONLY
	EXPORT	file_settype
file_settype

	STMFD	r13!,{r4,r5,lr}
	MOV	r2,r1
	MOV	r1,r0
	MOV	r0,#18
	SWI	XOS_File
	MOVVS	r0,#0
	MOVVC	r0,#1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_createdirectory|, CODE, READONLY
	EXPORT	file_createdirectory
file_createdirectory

	STMFD	r13!,{r4,r5,lr}
	MOV	r1,r0
	MOV	r2,#0
	MOV	r3,#0
	MOV	r0,#8
	SWI	XOS_File
	MOVVS	r0,#0
	MOVVC	r0,#1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_leaf|, CODE, READONLY
	EXPORT	file_leaf
file_leaf

	MOV	r1,r0
fl_lp	LDRB	r2,[r1],#1
	TEQ	r2,#'.'
	MOVEQ	r0,r1
	CMP	r2,#32
	BCS	fl_lp
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____file_save|, CODE, READONLY
	EXPORT	file_save
file_save

; r0 is ^ name
; r1 is ^ src
; r2 is load address
; r3 is exec address
; !r13 is size
	MOV	r12,r13
	STMFD	r13!,{r4,r5,lr}
	LDR	r5,[r12]
	MOV	r4,r1
	ADD	r5,r5,r4
	MOV	r1,r0
	MOV	r0,#0
	SWI	XOS_File
	MOVVC	r0,#0
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_create|, CODE, READONLY
	EXPORT	file_create
file_create

	STMFD	r13!,{r4,r5,lr}
	MOV	r4,#0
	MOV	r5,r1
	MOV	r2,#&ff0
	ORR	r2,r2,#&d
	MOV	r1,r0
	MOV	r0,#11
	SWI	XOS_File
	MOVVS	r0,#0
	MOVVC	r0,#1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____file_copyattributes|, CODE, READONLY
	EXPORT	file_copyattributes
file_copyattributes

; r0 is ^ dst
; r1 is ^ src

	STMFD	r13!,{r4-r6,lr}
	MOV	r6,r0
	MOV	r0,#5
	SWI	XOS_File
	MOV	r1,r6
	MOV	r0,#1
	SWI	XOS_File
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____file_datecmp|, CODE, READONLY
	EXPORT	file_datecmp
file_datecmp

; r0 is ^ date1
; r1 is ^ date2
; returns r0<0 if date1<date2
;         r0=0 if date1=date2
;         r1>0 if date1>date2

	LDRB	r2,[r0,#4]
	LDRB	r3,[r1,#4]
	CMP	r2,r3
	SUBNE	r0,r2,r3
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	LDRB	r2,[r0,#3]
	LDRB	r3,[r1,#3]
	CMP	r2,r3
	SUBNE	r0,r2,r3
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	LDRB	r2,[r0,#2]
	LDRB	r3,[r1,#2]
	CMP	r2,r3
	SUBNE	r0,r2,r3
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	LDRB	r2,[r0,#1]
	LDRB	r3,[r1,#1]
	CMP	r2,r3
	SUBNE	r0,r2,r3
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	LDRB	r2,[r0,#0]
	LDRB	r3,[r1,#0]
	SUB	r0,r2,r3
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____file_setloadexecattr|, CODE, READONLY
	EXPORT	file_setloadexecattr
file_setloadexecattr

	STMFD	r13!,{r5,lr}
	MOV	r5,r3
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r0
	MOV	r0,#1
	SWI	XOS_File
	MOVVC	r0,#0
 [ arm32
	LDMFD	r13!,{r5,pc}
 |
	LDMFD	r13!,{r5,pc}^
 ]

	END
